package be.iminds.jfed.gts_highlevel.model;

import org.testng.Assert;
import org.testng.annotations.Test;

import javax.xml.bind.JAXBContext;
import javax.xml.bind.JAXBException;
import javax.xml.bind.Unmarshaller;
import java.io.StringReader;

/**
 * User: twalcari
 * Date: 9/18/2015
 * Time: 17:57
 */
public class GtsResourceTest {

    @Test
    public void unmarshalGtsResource() throws JAXBException {
        final String input = "<composite>\n" +
                "    <capabilities>\n" +
                "        <entry>\n" +
                "            <key>id</key>\n" +
                "            <value>248103</value>\n" +
                "        </entry>\n" +
                "        <entry>\n" +
                "            <key>ports</key>\n" +
                "            <value>{}</value>\n" +
                "        </entry>\n" +
                "        <entry>\n" +
                "            <key>status</key>\n" +
                "            <value>ACTIVE</value>\n" +
                "        </entry>\n" +
                "        <entry>\n" +
                "            <key>providerId</key>\n" +
                "            <value>66</value>\n" +
                "        </entry>\n" +
                "        <entry>\n" +
                "            <key>type</key>\n" +
                "            <value>Testbed</value>\n" +
                "        </entry>\n" +
                "    </capabilities>\n" +
                "    <failOnActivate>false</failOnActivate>\n" +
                "    <failOnDeactivate>false</failOnDeactivate>\n" +
                "    <id>248103</id>\n" +
                "    <ports/>\n" +
                "    <providerId>66</providerId>\n" +
                "    <reservations>\n" +
                "        <children>\n" +
                "            <id>58</id>\n" +
                "            <endTime>17548354799000</endTime>\n" +
                "            <resourceProviderId>Host-1442504304395</resourceProviderId>\n" +
                "            <status>ACTIVE</status>\n" +
                "            <startTime>1442504280000</startTime>\n" +
                "        </children>\n" +
                "        <id>17</id>\n" +
                "        <endTime>17548354799000</endTime>\n" +
                "        <resourceProviderId>66</resourceProviderId>\n" +
                "        <status>ACTIVE</status>\n" +
                "        <startTime>1442504280000</startTime>\n" +
                "    </reservations>\n" +
                "    <status>ACTIVE</status>\n" +
                "    <type>Testbed</type>\n" +
                "    <name>JFEDTEST</name>\n" +
                "</composite>";

        JAXBContext context = JAXBContext.newInstance(GtsResource.class, GtsComposite.class);
        Unmarshaller unmarshaller = context.createUnmarshaller();

        GtsResource reservation = (GtsResource) unmarshaller.unmarshal(new StringReader(input));

        Assert.assertEquals(GtsReservation.Status.ACTIVE, reservation.getStatus());



    }
}
