package be.iminds.ilabt.jfed.highlevel.jobs;

import be.iminds.ilabt.jfed.experiment.Experiment;
import be.iminds.ilabt.jfed.experiment.tasks.ExperimentTaskStatus;
import be.iminds.ilabt.jfed.highlevel.model.EasyModel;
import be.iminds.ilabt.jfed.highlevel.model.UserSpecHelper;
import be.iminds.ilabt.jfed.lowlevel.GeniUserProvider;
import be.iminds.ilabt.jfed.lowlevel.api.user_spec.UserSpec;

import java.util.List;

/**
 * User: twalcari
 * Date: 12/4/2015
 * Time: 14:42
 */
public class CreateUserSpecListState extends State {
    private List<UserSpec> userSpecs = null;

    private final Experiment experiment;
    private final GeniUserProvider geniUserProvider;
    private final EasyModel easyModel;

    protected CreateUserSpecListState(Experiment experiment, GeniUserProvider geniUserProvider, EasyModel easyModel) {
        super("Gathering experiment members info");
        this.experiment = experiment;
        this.geniUserProvider = geniUserProvider;
        this.easyModel = easyModel;
    }

    @Override
    public ExperimentTaskStatus executeState() throws InterruptedException {
        userSpecs = UserSpecHelper.getMergedUserSpecs(geniUserProvider, easyModel,
                experiment.getSlice().getRequestRspec().getModelRspec());

        if (experiment.isIncludeProjectMemberSshKeys())
            userSpecs = UserSpecHelper.mergeUserSpecs(userSpecs,
                    UserSpecHelper.getSliceMemberUserSpecs(experiment.getSlice().getUrn(), easyModel));

        return ExperimentTaskStatus.SUCCESS;
    }

    public List<UserSpec> getUserSpecs() {
        return userSpecs;
    }
}
