package be.iminds.ilabt.jfed.highlevel.jobs;

import be.iminds.ilabt.jfed.experiment.tasks.ExperimentTaskStatus;
import be.iminds.ilabt.jfed.highlevel.controller.Task;
import be.iminds.ilabt.jfed.highlevel.controller.TaskExecution;

/**
 * User: twalcari
 * Date: 11/25/2015
 * Time: 10:12
 */
public abstract class SingleCallState<T extends Task> extends State {
    private AbstractJob<?> job;
    protected final T task;
    protected TaskExecution<T> taskExecution = null;

    protected SingleCallState(String name, AbstractJob<?> job, T task) {
        super(name);
        this.job = job;
        this.task = task;
    }

    public ExperimentTaskStatus executeState() throws InterruptedException {

        this.taskExecution = job.submitTaskAndWait(task);


        return taskExecution.getState() == TaskExecution.TaskState.SUCCESS ?
                ExperimentTaskStatus.SUCCESS :
                ExperimentTaskStatus.FAILED;
    }

    public T getTask() {
        return task;
    }

    public TaskExecution<T> getTaskExecution() {
        return taskExecution;
    }
}
