package be.iminds.ilabt.jfed.highlevel.jobs;

import be.iminds.ilabt.jfed.experiment.ExperimentPart;
import org.slf4j.Marker;
import org.slf4j.MarkerFactory;

/**
 * User: twalcari
 * Date: 11/25/2015
 * Time: 10:15
 */
public abstract class StatefulExperimentPartThread extends StatefulThread {
    protected final ExperimentPart experimentPart;
    protected final Marker logMarker;

    public StatefulExperimentPartThread(ExperimentPart experimentPart) {
        this.experimentPart = experimentPart;
        this.logMarker =
                MarkerFactory.getMarker(experimentPart.getExperiment().getName() + "-" + experimentPart.getName());

        setName(this.getClass().getName() + "-" + experimentPart.getExperiment().getName() + "-" + experimentPart.getName());
    }

    public ExperimentPart getExperimentPart() {
        return experimentPart;
    }
}
